## ring 20230206.0~ds2

=== daemon/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.16)

project(jami-daemon
    VERSION 13.7.0
    LANGUAGES C CXX)
set(PACKAGE_NAME "Jami Daemon")

################################################################################
# Build options
################################################################################
option(JAMI_NATPMP "Build with NAT-PMP" ON)
option(JAMI_PUPNP "Build with PUPNP" ON)
option(JAMI_PLUGIN "Build with plugin support" ON)
option(JAMI_JNI "Build the JNI binding" OFF)
option(JAMI_DBUS "Build the DBUS binding" OFF)
option(JAMI_VIDEO "Build with video support" ON)
option(BUILD_CONTRIB "Build contrib to CONTRIB_PATH" ON)
option(BUILD_EXTRA_TOOLS "Build extra tools" OFF)

if(NOT MSVC)
    ################################################################################
    # Contrib
    ################################################################################

    # Android target mapping for contrib
    if (ANDROID_ABI STREQUAL "x86")
        set(TARGET i686-linux-android)
    elseif (ANDROID_ABI STREQUAL "x86_64")
        set(TARGET x86_64-linux-android)
    elseif (ANDROID_ABI STREQUAL "arm64-v8a")
        set(TARGET aarch64-linux-android)
    elseif (ANDROID_ABI STREQUAL "armeabi-v7a")
        set(TARGET armv7a-linux-androideabi)
    else()
        set(TARGET ${CMAKE_LIBRARY_ARCHITECTURE})
        if (NOT TARGET)
            execute_process(COMMAND gcc -dumpmachine  COMMAND tr -d '\n' OUTPUT_VARIABLE TARGET)
        endif()
    endif()
    set(CONTRIB_PATH ${CMAKE_CURRENT_SOURCE_DIR}/contrib/${TARGET})

    include(ProcessorCount)
    ProcessorCount(NPROC)
    if(NOT NPROC EQUAL 0)
        set(CONTRIB_BUILD_FLAGS -j${NPROC})
    endif()

    if (BUILD_EXTRA_TOOLS)
        set(ENV{PATH} "${CMAKE_CURRENT_SOURCE_DIR}/extras/tools/build/bin:$ENV{PATH}")
        execute_process(
            COMMAND ./bootstrap
            WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/extras/tools)
        execute_process(
            COMMAND make ${CONTRIB_BUILD_FLAGS}
            WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/extras/tools)
        execute_process(
            COMMAND make .pkg-config
            WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/extras/tools)
        execute_process(
            COMMAND make .gas
            WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/extras/tools)
    endif()
    if (JAMI_JNI)
        # Generate swig binding
        add_custom_command(
            OUTPUT ${CMAKE_CURRENT_SOURCE_DIR}/bin/jni/jami_wrapper.cpp
            COMMAND env PACKAGEDIR=${JAMI_JNI_PACKAGEDIR} "./make-swig.sh"
            DEPENDS
            ${CMAKE_CURRENT_SOURCE_DIR}/bin/jni/make-swig.sh
            ${CMAKE_CURRENT_SOURCE_DIR}/bin/jni/jni_interface.i
            ${CMAKE_CURRENT_SOURCE_DIR}/bin/jni/callmanager.i
            ${CMAKE_CURRENT_SOURCE_DIR}/bin/jni/configurationmanager.i
            ${CMAKE_CURRENT_SOURCE_DIR}/bin/jni/conversation.i
            ${CMAKE_CURRENT_SOURCE_DIR}/bin/jni/managerimpl.i
            ${CMAKE_CURRENT_SOURCE_DIR}/bin/jni/data_view.i
            WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/bin/jni
        )
    endif()
    if (BUILD_CONTRIB)
        set(CONTRIB_BUILD_PATH ${CMAKE_CURRENT_SOURCE_DIR}/contrib/native-${TARGET})
        file(MAKE_DIRECTORY ${CONTRIB_BUILD_PATH})
        file(MAKE_DIRECTORY ${CONTRIB_PATH})

        if (ANDROID)
            # See https://developer.android.com/ndk/guides/other_build_systems
            set(ENV{ANDROID_NDK} ${ANDROID_NDK})
            set(ENV{ANDROID_ABI} ${ANDROID_ABI})
            set(ENV{ANDROID_API} ${ANDROID_PLATFORM})
            set(ENV{TOOLCHAIN} ${ANDROID_TOOLCHAIN_ROOT})
            set(ENV{TARGET} ${TARGET})
            set(ENV{API} ${ANDROID_PLATFORM_LEVEL})
            set(ENV{CC} $ENV{TOOLCHAIN}/bin/${TARGET}$ENV{API}-clang)
            set(ENV{CXX} $ENV{TOOLCHAIN}/bin/${TARGET}$ENV{API}-clang++)
            set(ENV{AS} "$ENV{CC} -c")
            set(ENV{AR} ${CMAKE_AR})
            set(ENV{RANLIB} ${CMAKE_RANLIB})
            set(ENV{STRIP} ${CMAKE_STRIP})
            set(ENV{LD} $ENV{TOOLCHAIN}/bin/ld)
        endif()

        execute_process(
            COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/contrib/bootstrap --host=${TARGET}
            WORKING_DIRECTORY ${CONTRIB_BUILD_PATH})
        execute_process(COMMAND make list
            WORKING_DIRECTORY ${CONTRIB_BUILD_PATH})
        execute_process(COMMAND make ${CONTRIB_BUILD_FLAGS}
            WORKING_DIRECTORY ${CONTRIB_BUILD_PATH})
    endif()
endif()

################################################################################
# Check dependencies
################################################################################

if(NOT MSVC)
    include(FindPkgConfig)
    if (JAMI_NATPMP)
        pkg_search_module (natpmp IMPORTED_TARGET natpmp)
        if (NOT natpmp_FOUND)
            find_library(natpmp_LIBRARIES natpmp)
            if (NOT natpmp_LIBRARIES)
                message("NAT-PMP not found: disabling")
                set(JAMI_NATPMP Off)
            endif()
        endif()
    endif()
    if (JAMI_PUPNP)
        pkg_search_module (upnp IMPORTED_TARGET upnp libupnp)
        if (NOT upnp_FOUND)
            set(JAMI_PUPNP Off)
        endif()
    endif()
    if(CMAKE_SYSTEM_NAME STREQUAL "Linux")
        pkg_search_module (udev REQUIRED IMPORTED_TARGET libudev)
        pkg_search_module (pulseaudio REQUIRED IMPORTED_TARGET libpulse)
    endif()
endif()

################################################################################
# Source groups
################################################################################

# compat, src source group
if(MSVC)
    add_subdirectory("compat")
endif()

add_subdirectory("src")
source_group("Source Files" FILES ${Source_Files})
source_group("Source Files\\client" FILES ${Source_Files__client})
source_group("Source Files\\config" FILES ${Source_Files__config})
source_group("Source Files\\connectivity" FILES ${Source_Files__connectivity})
source_group("Source Files\\connectivity\\security" FILES ${Source_Files__security})
source_group("Source Files\\connectivity\\sip" FILES ${Source_Files__sip})
source_group("Source Files\\connectivity\\upnp" FILES ${Source_Files__upnp})
source_group("Source Files\\connectivity\\upnp\\protocol" FILES ${Source_Files__upnp__protocol})
source_group("Source Files\\connectivity\\upnp\\protocol\\natpmp" FILES ${Source_Files__upnp__protocol__natpmp})
source_group("Source Files\\connectivity\\upnp\\protocol\\pupnp" FILES ${Source_Files__upnp__protocol__pupnp})
source_group("Source Files\\jami" FILES ${Source_Files__jami})
source_group("Source Files\\hooks" FILES ${Source_Files__hooks})
source_group("Source Files\\im" FILES ${Source_Files__im})
source_group("Source Files\\jamidht" FILES ${Source_Files__jamidht})
source_group("Source Files\\jamidht\\eth\\libdevcore" FILES ${Source_Files__jamidht__eth__libdevcore})
source_group("Source Files\\jamidht\\eth\\libdevcrypto" FILES ${Source_Files__jamidht__eth__libdevcrypto})
source_group("Source Files\\media" FILES ${Source_Files__media})
source_group("Source Files\\media\\audio" FILES ${Source_Files__media__audio})
source_group("Source Files\\media\\audio\\audio-processing" FILES ${Source_Files__media__audio__audio_processing})
source_group("Source Files\\media\\audio\\sound" FILES ${Source_Files__media__audio__sound})
source_group("Source Files\\media\\video" FILES ${Source_Files__media__video})
source_group("Source Files\\plugin" FILES ${Source_Files__plugin})

if(MSVC)
   if(WINDOWS_STORE)
      source_group("Source Files\\media\\video\\uwpvideo" FILES ${Source_Files__media__video__uwpvideo})
   endif()
   source_group("Source Files\\media\\audio\\portaudio" FILES ${Source_Files__media__audio__portaudio})
   source_group("Source Files\\media\\video\\winvideo" FILES ${Source_Files__media__video__winvideo})
endif()

list (APPEND ALL_FILES
      ${Source_Files}
      ${Source_Files__client}
      ${Source_Files__config}
      ${Source_Files__connectivity}
      ${Source_Files__jami}
      ${Source_Files__hooks}
      ${Source_Files__im}
      ${Source_Files__jamidht}
      ${Source_Files__jamidht__eth__libdevcore}
      ${Source_Files__jamidht__eth__libdevcrypto}
      ${Source_Files__media}
      ${Source_Files__media__audio}
      ${Source_Files__media__audio__sound}
      ${Source_Files__media__audio__audio_processing}
      ${Source_Files__media__video}
      ${Source_Files__security}
      ${Source_Files__sip}
      ${Source_Files__upnp}
      ${Source_Files__upnp__protocol}
)
if (JAMI_NATPMP)
    list (APPEND ALL_FILES ${Source_Files__upnp__protocol__natpmp})
endif()
if (JAMI_PUPNP)
    list (APPEND ALL_FILES ${Source_Files__upnp__protocol__pupnp})
endif()
if (JAMI_PLUGIN)
    list (APPEND ALL_FILES ${Source_Files__plugin})
endif()
if (ANDROID)
    list (APPEND ALL_FILES ${ALL_FILES}
        ${CMAKE_CURRENT_SOURCE_DIR}/src/media/video/androidvideo/video_device_impl.cpp
        ${CMAKE_CURRENT_SOURCE_DIR}/src/media/video/androidvideo/video_device_monitor_impl.cpp
        ${CMAKE_CURRENT_SOURCE_DIR}/src/media/audio/opensl/audio_player.cpp
        ${CMAKE_CURRENT_SOURCE_DIR}/src/media/audio/opensl/audio_recorder.cpp
        ${CMAKE_CURRENT_SOURCE_DIR}/src/media/audio/opensl/opensllayer.cpp
    )
elseif (CMAKE_SYSTEM_NAME STREQUAL "Linux")
    if (JAMI_VIDEO)
        list (APPEND ALL_FILES ${ALL_FILES}
            ${CMAKE_CURRENT_SOURCE_DIR}/src/media/video/v4l2/video_device_impl.cpp
            ${CMAKE_CURRENT_SOURCE_DIR}/src/media/video/v4l2/video_device_monitor_impl.cpp
        )
    endif()
    list (APPEND ALL_FILES ${ALL_FILES}
        ${CMAKE_CURRENT_SOURCE_DIR}/src/media/audio/pulseaudio/audiostream.cpp
        ${CMAKE_CURRENT_SOURCE_DIR}/src/media/audio/pulseaudio/pulselayer.cpp
    )
elseif(MSVC)
   list (APPEND ALL_FILES ${ALL_FILES}
         "${Source_Files__media__audio__portaudio}"
         "${Source_Files__media__video__uwpvideo}"
         "${Source_Files__media__video__winvideo}"
   )
endif()

add_library(${PROJECT_NAME} STATIC ${ALL_FILES})
set_target_properties(${PROJECT_NAME} PROPERTIES FOLDER "daemon")
set_target_properties (${PROJECT_NAME} PROPERTIES CXX_STANDARD 17)
target_compile_definitions(${PROJECT_NAME} PRIVATE
    PACKAGE_NAME="${PACKAGE_NAME}"
    PACKAGE_VERSION="${PROJECT_VERSION}"
    PACKAGE="jami"
    LIBJAMI_BUILD
    HAVE_RINGNS
    ASIO_STANDALONE
    MSGPACK_NO_BOOST
)
if (JAMI_VIDEO)
    target_compile_definitions(${PROJECT_NAME} PRIVATE ENABLE_VIDEO)
endif()
if (JAMI_PLUGIN)
    target_compile_definitions(${PROJECT_NAME} PRIVATE ENABLE_PLUGIN)
endif()
if (JAMI_NATPMP)
    target_compile_definitions(${PROJECT_NAME} PRIVATE HAVE_LIBNATPMP)
endif()
if (ANDROID)
    target_compile_definitions(${PROJECT_NAME} PRIVATE HAVE_OPENSL)
endif()
target_include_directories(${PROJECT_NAME} PRIVATE
    "${CMAKE_CURRENT_SOURCE_DIR}/.;"
    "${CMAKE_CURRENT_SOURCE_DIR}/src/config;"
    "${CMAKE_CURRENT_SOURCE_DIR}/src/connectivity;"
    "${CMAKE_CURRENT_SOURCE_DIR}/src/connectivity/security;"
    "${CMAKE_CURRENT_SOURCE_DIR}/src/connectivity/sip;"
    "${CMAKE_CURRENT_SOURCE_DIR}/src/connectivity/upnp;"
    "${CMAKE_CURRENT_SOURCE_DIR}/src/connectivity/upnp/igd;"
    "${CMAKE_CURRENT_SOURCE_DIR}/src/connectivity/upnp/protocol;"
    "${CMAKE_CURRENT_SOURCE_DIR}/src/connectivity/upnp/mapping;"
    "${CMAKE_CURRENT_SOURCE_DIR}/src/client;"
    "${CMAKE_CURRENT_SOURCE_DIR}/src/hooks;"
    "${CMAKE_CURRENT_SOURCE_DIR}/src/im;"
    "${CMAKE_CURRENT_SOURCE_DIR}/src/media;"
    "${CMAKE_CURRENT_SOURCE_DIR}/src/jamidht;"
    "${CMAKE_CURRENT_SOURCE_DIR}/src/jamidht/eth;"
    PUBLIC
    "${CMAKE_CURRENT_SOURCE_DIR}/src;"
    "${CMAKE_CURRENT_SOURCE_DIR}/src/jami;"
)

if(MSVC)
   ################################################################################
   # Target
   ################################################################################
   include("CMake/Utils.cmake")
   use_props(${PROJECT_NAME} "${CMAKE_CONFIGURATION_TYPES}" "${DEFAULT_CXX_PROPS}")

=== 3rdparty/SortFilterProxyModel/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.14)

set(CMAKE_CXX_STANDARD 17)

find_package(Qt6 REQUIRED COMPONENTS
    Core
    Qml
)

option(BUILD_SFPM_PIC "Build with -fPIC" OFF)

set(CMAKE_POSITION_INDEPENDENT_CODE ${BUILD_SFPM_PIC})

set(CMAKE_AUTOMOC ON)
set(CMAKE_INCLUDE_CURRENT_DIR ON) # This is to find generated *.moc and *.h files in build dir

add_library(SortFilterProxyModel OBJECT
    qqmlsortfilterproxymodel.cpp
    filters/filter.cpp
    filters/filtercontainer.cpp
    filters/rolefilter.cpp
    filters/valuefilter.cpp
    filters/indexfilter.cpp
    filters/regexpfilter.cpp
    filters/rangefilter.cpp
    filters/expressionfilter.cpp
    filters/filtercontainerfilter.cpp
    filters/anyoffilter.cpp
    filters/alloffilter.cpp
    filters/filtersqmltypes.cpp
    sorters/sorter.cpp
    sorters/sortercontainer.cpp
    sorters/rolesorter.cpp
    sorters/stringsorter.cpp
    sorters/expressionsorter.cpp
    sorters/sortersqmltypes.cpp
    proxyroles/proxyrole.cpp
    proxyroles/proxyrolecontainer.cpp
    proxyroles/joinrole.cpp
    proxyroles/switchrole.cpp
    proxyroles/expressionrole.cpp
    proxyroles/proxyrolesqmltypes.cpp   
    proxyroles/singlerole.cpp   
    proxyroles/regexprole.cpp
    sorters/filtersorter.cpp
    proxyroles/filterrole.cpp
    utils/utils.cpp
    utils/utils.h
)

if ((MSVC) AND (MSVC_VERSION GREATER_EQUAL 1914))
    target_compile_options(SortFilterProxyModel PUBLIC "/Zc:__cplusplus")
    target_compile_options(SortFilterProxyModel PUBLIC "/permissive-")
endif()

target_include_directories(SortFilterProxyModel PUBLIC
    ${CMAKE_CURRENT_LIST_DIR}
    $<TARGET_PROPERTY:Qt6::Core,INTERFACE_INCLUDE_DIRECTORIES>
    $<TARGET_PROPERTY:Qt6::Qml,INTERFACE_INCLUDE_DIRECTORIES>
)

=== daemon/src/client/CMakeLists.txt ===
################################################################################
# Source groups - client
################################################################################
list (APPEND Source_Files__client
      "${CMAKE_CURRENT_SOURCE_DIR}/callmanager.cpp"
      "${CMAKE_CURRENT_SOURCE_DIR}/configurationmanager.cpp"
      "${CMAKE_CURRENT_SOURCE_DIR}/datatransfer.cpp"
      "${CMAKE_CURRENT_SOURCE_DIR}/presencemanager.cpp"
      "${CMAKE_CURRENT_SOURCE_DIR}/ring_signal.cpp"
      "${CMAKE_CURRENT_SOURCE_DIR}/ring_signal.h"
      "${CMAKE_CURRENT_SOURCE_DIR}/videomanager.cpp"
      "${CMAKE_CURRENT_SOURCE_DIR}/videomanager.h"
      "${CMAKE_CURRENT_SOURCE_DIR}/plugin_manager_interface.cpp"
      "${CMAKE_CURRENT_SOURCE_DIR}/conversation_interface.cpp"
)

set (Source_Files__client ${Source_Files__client} PARENT_SCOPE)

=== daemon/src/media/audio/CMakeLists.txt ===
################################################################################
# Source groups - audio
################################################################################

# alsa|coreaudio|jack|opensl|portaudio|pulseaudio|sound

list (APPEND Source_Files__media__audio
      "${CMAKE_CURRENT_SOURCE_DIR}/audio_frame_resizer.cpp"
      "${CMAKE_CURRENT_SOURCE_DIR}/audio_frame_resizer.h"
      "${CMAKE_CURRENT_SOURCE_DIR}/audio_input.cpp"
      "${CMAKE_CURRENT_SOURCE_DIR}/audio_input.h"
      "${CMAKE_CURRENT_SOURCE_DIR}/audio_receive_thread.cpp"
      "${CMAKE_CURRENT_SOURCE_DIR}/audio_receive_thread.h"
      "${CMAKE_CURRENT_SOURCE_DIR}/audio_rtp_session.cpp"
      "${CMAKE_CURRENT_SOURCE_DIR}/audio_rtp_session.h"
      "${CMAKE_CURRENT_SOURCE_DIR}/audio_sender.cpp"
      "${CMAKE_CURRENT_SOURCE_DIR}/audio_sender.h"
      "${CMAKE_CURRENT_SOURCE_DIR}/audiobuffer.cpp"
      "${CMAKE_CURRENT_SOURCE_DIR}/audiobuffer.h"
      "${CMAKE_CURRENT_SOURCE_DIR}/audiolayer.cpp"
      "${CMAKE_CURRENT_SOURCE_DIR}/audiolayer.h"
      "${CMAKE_CURRENT_SOURCE_DIR}/audioloop.cpp"
      "${CMAKE_CURRENT_SOURCE_DIR}/audioloop.h"
      "${CMAKE_CURRENT_SOURCE_DIR}/dcblocker.cpp"
      "${CMAKE_CURRENT_SOURCE_DIR}/dcblocker.h"
      "${CMAKE_CURRENT_SOURCE_DIR}/resampler.cpp"
      "${CMAKE_CURRENT_SOURCE_DIR}/resampler.h"
      "${CMAKE_CURRENT_SOURCE_DIR}/ringbuffer.cpp"
      "${CMAKE_CURRENT_SOURCE_DIR}/ringbuffer.h"
      "${CMAKE_CURRENT_SOURCE_DIR}/ringbufferpool.cpp"
      "${CMAKE_CURRENT_SOURCE_DIR}/ringbufferpool.h"
      "${CMAKE_CURRENT_SOURCE_DIR}/tonecontrol.cpp"
      "${CMAKE_CURRENT_SOURCE_DIR}/tonecontrol.h"
)

if(NOT MSVC)
   list (APPEND Source_Files__media__audio
         "${CMAKE_CURRENT_SOURCE_DIR}/dsp.cpp"
         "${CMAKE_CURRENT_SOURCE_DIR}/dsp.h"
   )
endif()

set (Source_Files__media__audio ${Source_Files__media__audio} PARENT_SCOPE)

if(MSVC)
   add_subdirectory(portaudio)
   set (Source_Files__media__audio__portaudio ${Source_Files__media__audio__portaudio} PARENT_SCOPE)
endif()

add_subdirectory(sound)
set (Source_Files__media__audio__sound ${Source_Files__media__audio__sound} PARENT_SCOPE)

add_subdirectory(audio-processing)
set (Source_Files__media__audio__audio_processing ${Source_Files__media__audio__audio_processing} PARENT_SCOPE)

=== daemon/src/media/audio/audio-processing/CMakeLists.txt ===
################################################################################
# Source groups - audio-processing
################################################################################
list (APPEND Source_Files__media__audio__audio_processing
      "${CMAKE_CURRENT_SOURCE_DIR}/audio_processor.h"
      "${CMAKE_CURRENT_SOURCE_DIR}/null_audio_processor.h"
      "${CMAKE_CURRENT_SOURCE_DIR}/null_audio_processor.cpp"
      "${CMAKE_CURRENT_SOURCE_DIR}/speex.h"
      "${CMAKE_CURRENT_SOURCE_DIR}/speex.cpp"
      "${CMAKE_CURRENT_SOURCE_DIR}/webrtc.h"
      "${CMAKE_CURRENT_SOURCE_DIR}/webrtc.cpp"
)

set (Source_Files__media__audio__audio_processing ${Source_Files__media__audio__audio_processing} PARENT_SCOPE)

=== daemon/contrib/tarballs-unpacked/pjproject-3b78ef1c48732d238ba284cdccb04dc6de79c54f.tar.gz/pjproject-3b78ef1c48732d238ba284cdccb04dc6de79c54f/third_party/build/milenage/Makefile ===
include ../../../build.mak
include ../../../build/common.mak

export LIBDIR := ../../lib

RULES_MAK := $(PJDIR)/build/rules.mak

export MILENAGE_LIB := libmilenage-$(TARGET_NAME)$(LIBEXT)

ifeq ($(PJ_SHARED_LIBRARIES),)
else
export MILENAGE_SONAME := libmilenage.$(SHLIB_SUFFIX)
export MILENAGE_SHLIB := $(MILENAGE_SONAME).$(PJ_VERSION_MAJOR)
endif

###############################################################################
# Gather all flags.
#
export _CFLAGS 	:= $(CC_CFLAGS) $(OS_CFLAGS) $(HOST_CFLAGS) $(M_CFLAGS) \
		   $(CFLAGS) $(CC_INC). $(CC_INC)../../milenage/include \
		   $(CC_INC)../../../pjlib/include
export _CXXFLAGS:= $(_CFLAGS) $(CC_CXXFLAGS) $(OS_CXXFLAGS) $(M_CXXFLAGS) \
		   $(HOST_CXXFLAGS) $(CXXFLAGS)
export _LDFLAGS := $(CC_LDFLAGS) $(OS_LDFLAGS) $(M_LDFLAGS) $(HOST_LDFLAGS) \
		   $(LDFLAGS) 

export MILENAGE_SRCDIR = ../../milenage
export MILENAGE_OBJS = milenage.o rijndael.o
export MILENAGE_CFLAGS = $(_CFLAGS)


export CC_OUT CC AR RANLIB HOST_MV HOST_RM HOST_RMDIR HOST_MKDIR OBJEXT LD LDOUT 
###############################################################################
# Main entry
#
# $(TARGET) is defined in os-$(OS_NAME).mak file in current directory.
#
TARGETS := $(MILENAGE_LIB) $(MILENAGE_SONAME)

all: $(TARGETS)

doc:
	cd .. && doxygen docs/doxygen.cfg

dep: depend
distclean: realclean

.PHONY: all dep depend clean realclean distclean
.PHONY: $(TARGETS)
.PHONY: $(MILENAGE_LIB) $(MILENAGE_SONAME)

libmilenage: $(MILENAGE_LIB)
$(MILENAGE_SONAME): $(MILENAGE_LIB)
$(MILENAGE_LIB) $(MILENAGE_SONAME):
	$(MAKE) -f $(RULES_MAK) APP=MILENAGE app=libmilenage $(subst /,$(HOST_PSEP),$(LIBDIR)/$@)

clean print_lib:
	$(MAKE) -f $(RULES_MAK) APP=MILENAGE app=libmilenage $@

realclean:
	$(subst @@,$(subst /,$(HOST_PSEP),.ilbc-$(TARGET_NAME).depend),$(HOST_RMR))
	
	$(MAKE) -f $(RULES_MAK) APP=MILENAGE app=libmilenage $@

depend:
	$(MAKE) -f $(RULES_MAK) APP=MILENAGE app=libmilenage $@

=== daemon/contrib/tarballs-unpacked/pjproject-3b78ef1c48732d238ba284cdccb04dc6de79c54f.tar.gz/pjproject-3b78ef1c48732d238ba284cdccb04dc6de79c54f/third_party/build/webrtc_aec3/Makefile ===
include ../../../build.mak
include ../../../build/common.mak
include ../os-$(OS_NAME).mak

export LIBDIR := ../../lib

RULES_MAK := $(PJDIR)/build/rules.mak

export WEBRTC_AEC3_LIB := libwebrtc-aec3-$(TARGET_NAME)$(LIBEXT)

ifeq ($(PJ_SHARED_LIBRARIES),)
else
export WEBRTC_AEC3_SONAME := libwebrtc-aec3.$(SHLIB_SUFFIX)
export WEBRTC_AEC3_SHLIB := $(WEBRTC_AEC3_SONAME).$(PJ_VERSION_MAJOR)
endif

###############################################################################
# Gather all flags.
#
export _CFLAGS 	:= $(CC_CFLAGS) $(OS_CFLAGS) $(HOST_CFLAGS) $(M_CFLAGS) \
		   $(CFLAGS) $(CC_INC). $(CC_INC)../../webrtc_aec3/src  \
		   $(CC_INC)../../../pjlib/include
export _CXXFLAGS:= $(CC_CXXFLAGS) $(OS_CXXFLAGS) $(M_CXXFLAGS) \
		   $(HOST_CXXFLAGS) $(CXXFLAGS) $(_CFLAGS)
export _LDFLAGS := $(CC_LDFLAGS) $(OS_LDFLAGS) $(M_LDFLAGS) $(HOST_LDFLAGS) \
		   $(LDFLAGS) 

export WEBRTC_AEC3_SRCDIR = ../../webrtc_aec3/src/
export WEBRTC_AEC3_OBJS = \
	absl/types/bad_optional_access.o \
	common_audio/audio_util.o \
	common_audio/third_party/ooura/fft_size_128/ooura_fft.o \
	common_audio/third_party/ooura/fft_size_256/fft4g.o \
	common_audio/resampler/push_resampler.o \
	common_audio/resampler/push_sinc_resampler.o \
	common_audio/resampler/sinc_resampler.o \
	common_audio/signal_processing/splitting_filter2.o \
	api/audio/channel_layout.o \
	api/audio/echo_canceller3_config.o \
	api/audio/echo_canceller3_factory.o \
	api/audio/echo_detector_creator.o \
	modules/audio_processing/audio_buffer.o \
	modules/audio_processing/gain_controller2.o \
	modules/audio_processing/high_pass_filter.o \
	modules/audio_processing/splitting_filter.o \
	modules/audio_processing/three_band_filter_bank.o \
	modules/audio_processing/aec3/adaptive_fir_filter_erl.o \
	modules/audio_processing/aec3/adaptive_fir_filter.o \
	modules/audio_processing/aec3/aec_state.o \
	modules/audio_processing/aec3/aec3_common.o \
	modules/audio_processing/aec3/aec3_fft.o \
	modules/audio_processing/aec3/alignment_mixer.o \
	modules/audio_processing/aec3/api_call_jitter_metrics.o \
	modules/audio_processing/aec3/block_framer.o \
	modules/audio_processing/aec3/block_delay_buffer.o \
	modules/audio_processing/aec3/block_buffer.o \
	modules/audio_processing/aec3/block_processor_metrics.o \
	modules/audio_processing/aec3/block_processor.o \
	modules/audio_processing/aec3/clockdrift_detector.o \
	modules/audio_processing/aec3/coarse_filter_update_gain.o \
	modules/audio_processing/aec3/comfort_noise_generator.o \
	modules/audio_processing/aec3/decimator.o \
	modules/audio_processing/aec3/dominant_nearend_detector.o \
	modules/audio_processing/aec3/downsampled_render_buffer.o \
	modules/audio_processing/aec3/echo_audibility.o \
	modules/audio_processing/aec3/echo_canceller3.o \
	modules/audio_processing/aec3/echo_path_delay_estimator.o \
	modules/audio_processing/aec3/echo_path_variability.o \
	modules/audio_processing/aec3/echo_remover_metrics.o \
	modules/audio_processing/aec3/echo_remover.o \
	modules/audio_processing/aec3/erl_estimator.o \
	modules/audio_processing/aec3/erle_estimator.o \
	modules/audio_processing/aec3/fft_buffer.o \
	modules/audio_processing/aec3/filter_analyzer.o \
	modules/audio_processing/aec3/frame_blocker.o \
	modules/audio_processing/aec3/fullband_erle_estimator.o \
	modules/audio_processing/aec3/matched_filter_lag_aggregator.o \
	modules/audio_processing/aec3/matched_filter.o \
	modules/audio_processing/aec3/moving_average.o \
	modules/audio_processing/aec3/refined_filter_update_gain.o \
	modules/audio_processing/aec3/render_buffer.o \
	modules/audio_processing/aec3/render_delay_buffer.o \
	modules/audio_processing/aec3/render_delay_controller_metrics.o \
	modules/audio_processing/aec3/render_delay_controller.o \
	modules/audio_processing/aec3/render_signal_analyzer.o \
	modules/audio_processing/aec3/residual_echo_estimator.o \
	modules/audio_processing/aec3/reverb_decay_estimator.o \
	modules/audio_processing/aec3/reverb_frequency_response.o \
	modules/audio_processing/aec3/reverb_model_estimator.o \
	modules/audio_processing/aec3/reverb_model.o \
	modules/audio_processing/aec3/signal_dependent_erle_estimator.o \
	modules/audio_processing/aec3/spectrum_buffer.o \
	modules/audio_processing/aec3/stationarity_estimator.o \
	modules/audio_processing/aec3/subband_erle_estimator.o \
	modules/audio_processing/aec3/subband_nearend_detector.o \
	modules/audio_processing/aec3/subtractor_output_analyzer.o \
	modules/audio_processing/aec3/subtractor_output.o \
	modules/audio_processing/aec3/subtractor.o \
	modules/audio_processing/aec3/suppression_filter.o \
	modules/audio_processing/aec3/suppression_gain.o \
	modules/audio_processing/aec3/transparent_mode.o \
	modules/audio_processing/agc2/adaptive_agc.o \
	modules/audio_processing/agc2/adaptive_digital_gain_applier.o \
	modules/audio_processing/agc2/adaptive_mode_level_estimator.o \
	modules/audio_processing/agc2/biquad_filter.o \
	modules/audio_processing/agc2/compute_interpolated_gain_curve.o \
	modules/audio_processing/agc2/cpu_features.o \
	modules/audio_processing/agc2/down_sampler.o \
	modules/audio_processing/agc2/fixed_digital_level_estimator.o \
	modules/audio_processing/agc2/gain_applier.o \
	modules/audio_processing/agc2/interpolated_gain_curve.o \
	modules/audio_processing/agc2/limiter_db_gain_curve.o \
	modules/audio_processing/agc2/limiter.o \
	modules/audio_processing/agc2/noise_level_estimator.o \
	modules/audio_processing/agc2/noise_spectrum_estimator.o \
	modules/audio_processing/agc2/saturation_protector_buffer.o \
	modules/audio_processing/agc2/saturation_protector.o \
	modules/audio_processing/agc2/signal_classifier.o \
	modules/audio_processing/agc2/vad_with_level.o \
	modules/audio_processing/agc2/vector_float_frame.o \
	modules/audio_processing/agc2/rnn_vad/auto_correlation.o \
	modules/audio_processing/agc2/rnn_vad/features_extraction.o \
	modules/audio_processing/agc2/rnn_vad/lp_residual.o \
	modules/audio_processing/agc2/rnn_vad/rnn.o \
	modules/audio_processing/agc2/rnn_vad/rnn_fc.o \
	modules/audio_processing/agc2/rnn_vad/rnn_gru.o \
	modules/audio_processing/agc2/rnn_vad/pitch_search_internal.o \
	modules/audio_processing/agc2/rnn_vad/pitch_search.o \
	modules/audio_processing/agc2/rnn_vad/spectral_features_internal.o \
	modules/audio_processing/agc2/rnn_vad/spectral_features.o \
	modules/audio_processing/ns/fast_math.o \
	modules/audio_processing/ns/histograms.o \
	modules/audio_processing/ns/noise_estimator.o \
	modules/audio_processing/ns/noise_suppressor.o \
	modules/audio_processing/ns/ns_fft.o \
	modules/audio_processing/ns/prior_signal_model_estimator.o \
	modules/audio_processing/ns/prior_signal_model.o \
	modules/audio_processing/ns/quantile_noise_estimator.o \
	modules/audio_processing/ns/signal_model_estimator.o \
	modules/audio_processing/ns/signal_model.o \
	modules/audio_processing/ns/speech_probability_estimator.o \
	modules/audio_processing/ns/suppression_params.o \
	modules/audio_processing/ns/wiener_filter.o \
	modules/audio_processing/logging/apm_data_dumper.o \
	modules/audio_processing/utility/cascaded_biquad_filter.o \
	modules/audio_processing/utility/delay_estimator_wrapper.o \
	modules/audio_processing/utility/delay_estimator.o \
	modules/audio_processing/utility/pffft_wrapper.o \
	rtc_base/checks.o \
	rtc_base/logging.o \
	rtc_base/platform_thread_types.o \
	rtc_base/race_checker.o \
	rtc_base/string_encode.o \
	rtc_base/string_to_number.o \
	rtc_base/string_utils.o \
	rtc_base/system_time.o \
	rtc_base/time_utils.o \
	rtc_base/experiments/field_trial_parser.o \
	rtc_base/memory/aligned_malloc.o \
	rtc_base/strings/string_builder.o \
	rtc_base/synchronization/mutex.o \
	rtc_base/synchronization/yield.o \
	rtc_base/system/file_wrapper.o \
	system_wrappers/source/cpu_features2.o \
	system_wrappers/source/field_trial.o \
	system_wrappers/source/metrics.o \
	third_party/rnnoise/src/rnn_vad_weights.o \
	third_party/pffft/src/pffft.o \
	$(WEBRTC_AEC3_SRC)

export WEBRTC_AEC3_CFLAGS = $(_CFLAGS) $(WEBRTC_AEC3_OTHER_CFLAGS)
export WEBRTC_AEC3_CXXFLAGS = $(WEBRTC_AEC3_CFLAGS) $(_CXXFLAGS)


export CC_OUT CC AR RANLIB HOST_MV HOST_RM HOST_RMDIR HOST_MKDIR OBJEXT LD LDOUT 
###############################################################################
# Main entry
#
# $(TARGET) is defined in os-$(OS_NAME).mak file in current directory.
#
TARGETS := $(WEBRTC_AEC3_LIB) $(WEBRTC_AEC3_SONAME)

all: $(TARGETS)

doc:
	cd .. && doxygen docs/doxygen.cfg

dep: depend
distclean: realclean

.PHONY: all dep depend clean realclean distclean
.PHONY: $(TARGETS)
.PHONY: $(WEBRTC_AEC3_LIB) $(WEBRTC_AEC3_SONAME)

libwebrtc-aec3: $(WEBRTC_AEC3_LIB)
$(WEBRTC_AEC3_SONAME): $(WEBRTC_AEC3_LIB)
$(WEBRTC_AEC3_LIB) $(WEBRTC_AEC3_SONAME):
	$(MAKE) -f $(RULES_MAK) APP=WEBRTC_AEC3 app=libwebrtc-aec3 $(subst /,$(HOST_PSEP),$(LIBDIR)/$@)

clean print_lib:
	$(MAKE) -f $(RULES_MAK) APP=WEBRTC_AEC3 app=libwebrtc-aec3 $@

realclean:
	$(subst @@,$(subst /,$(HOST_PSEP),.webrtc-aec3-$(TARGET_NAME).depend),$(HOST_RMR))
	
	$(MAKE) -f $(RULES_MAK) APP=WEBRTC_AEC3 app=libwebrtc-aec3 $@

depend:
	$(MAKE) -f $(RULES_MAK) APP=WEBRTC_AEC3 app=libwebrtc-aec3 $@

=== daemon/contrib/tarballs-unpacked/pjproject-3b78ef1c48732d238ba284cdccb04dc6de79c54f.tar.gz/pjproject-3b78ef1c48732d238ba284cdccb04dc6de79c54f/pjsip-apps/src/swig/java/Makefile ===
include ../../../../build.mak
include ../../../../build/common.mak

SWIG_FLAGS=-I../../../../pjlib/include \
		   -I../../../../pjlib-util/include \
		   -I../../../../pjmedia/include \
		   -I../../../../pjsip/include \
		   -I../../../../pjnath/include -c++ 
SRC_DIR=../../../../pjsip/include
SRCS=$(SRC_DIR)/pjsua2/endpoint.hpp $(SRC_DIR)/pjsua2/types.hpp

ifneq ($(findstring android,$(TARGET_NAME)),)
 OS=android
 ifeq ("$(JAVA_HOME)","")
   # Set dummy JAVA_HOME as JNI is bundled in Android NDK, only need javac here
   JAVA_HOME := $(dir $(shell which javac))
 endif
else
 ifneq ($(findstring darwin,$(TARGET_NAME)),)
  OS=darwin
 endif
endif

OUT_DIR=output
ifeq ($(OS),Windows_NT)
  LIBPJSUA2_SO=$(OUT_DIR)/pjsua2.dll
else
  ifeq ($(OS),darwin)
    LIBPJSUA2_SO=$(OUT_DIR)/libpjsua2.jnilib
  else
    ifeq ($(OS),android)
      LIBPJSUA2_SO=android/pjsua2/src/main/jniLibs/$(TARGET_ARCH)/libpjsua2.so
    else
      LIBPJSUA2_SO=$(OUT_DIR)/libpjsua2.so
    endif
  endif
endif

# Get JDK location
ifeq ("$(JAVA_HOME)","")

  verify_jdk  = $(shell test -d $(1)/include && test -d $(1)/lib && \
                	echo inclib1) \
                $(shell test -d $(1)/Headers && test -d $(1)/Libraries && \
			echo inclib2) \
                $(shell test -x $(1)/bin/javac && echo bin1) \
                $(shell test -x $(1)/Commands/javac && echo bin2) \
                $(shell test -x $(1)/javac && echo bin3)

  get_java_inc = $(if $(findstring inclib1,$(1)),$(2)/include,\
		 $(if $(findstring inclib2,$(1)),$(2)/Headers,))
  get_java_lib = $(if $(findstring inclib1,$(1)),$(2)/lib,\
		 $(if $(findstring inclib2,$(1)),$(2)/Libraries,))
  get_java_bin = $(if $(findstring bin1,$(1)),$(2)/bin,\
		 $(if $(findstring bin2,$(1)),$(2)/Commands,\
		 $(if $(findstring bin3,$(1)),$(2),)))


  # Check with 'which javac'
  WHICH_JAVAC := $(shell which javac)
  ifneq ($(WHICH_JAVAC),)
    WHICH_JAVAC := $(dir $(realpath $(WHICH_JAVAC)))
    WHICH_JAVAC := $(patsubst %/bin/,%,$(WHICH_JAVAC))
    TMP_RES := $(call verify_jdk,$(WHICH_JAVAC))
    ifneq ($(findstring inclib,$(TMP_RES)),)
      JAVA_HOME := $(WHICH_JAVAC)
      JAVA_INC  := $(call get_java_inc,$(TMP_RES),$(JAVA_HOME))
      JAVA_LIB  := $(call get_java_lib,$(TMP_RES),$(JAVA_HOME))
    endif
  endif

  # MacOS specifics
  ifeq ($(OS)$(JAVA_HOME),darwin)

    # Check with '/usr/libexec/java_home'
    # (see https://developer.apple.com/library/mac/qa/qa1170/_index.html)
    TMP_PATH := $(shell /usr/libexec/java_home)
    ifneq ("$(TMP_PATH)","")
      TMP_RES := $(call verify_jdk,$(TMP_PATH))
      ifneq ($(findstring inclib,$(TMP_RES)),)
        JAVA_HOME := $(TMP_PATH)
        JAVA_INC  := $(call get_java_inc,$(TMP_RES),$(JAVA_HOME))
        JAVA_LIB  := $(call get_java_lib,$(TMP_RES),$(JAVA_HOME))
      endif
    endif

    ifeq ($(JAVA_HOME),)
      # Check '/System/Library/Frameworks/JavaVM.framework'
      FIXED_PATH := /System/Library/Frameworks/JavaVM.framework
      TMP_RES := $(call verify_jdk,$(FIXED_PATH))
      ifneq ($(findstring inclib,$(TMP_RES)),)
        JAVA_HOME := $(FIXED_PATH)
        JAVA_INC  := $(call get_java_inc,$(TMP_RES),$(JAVA_HOME))
        JAVA_LIB  := $(call get_java_lib,$(TMP_RES),$(JAVA_HOME))
      endif
    endif

  endif

  ifneq ($(findstring bin,$(TMP_RES)),)
    JAVA_BIN := $(call get_java_bin,$(TMP_RES),$(JAVA_HOME))
  endif

#  $(info TMP_RES = $(TMP_RES))
#  $(info JAVA_HOME = $(JAVA_HOME))
#  $(info JAVA_INC  = $(JAVA_INC))
#  $(info JAVA_LIB  = $(JAVA_LIB))
#  $(info JAVA_BIN  = $(JAVA_BIN))
#  $(error done)

  ifeq ("$(JAVA_HOME)","")
    $(error Cannot determine JDK include/library path. \
            Please define JAVA_HOME envvar)
  endif

  ifeq ("$(JAVA_BIN)","")
    JAVA_BIN := $(JAVA_HOME)/bin
    $(warning Cannot determine JDK binary path. Set to $(JAVA_BIN))
  endif

else

  JAVA_INC := $(JAVA_HOME)/include
  JAVA_LIB := $(JAVA_HOME)/lib
  ifeq (exists,$(shell test -d "$(JAVA_HOME)/bin" && echo exists))
    JAVA_BIN := $(JAVA_HOME)/bin
  else
    JAVA_BIN := $(JAVA_HOME)
  endif

endif

# Env settings, e.g: path to SWIG, JDK, java(.exe), javac(.exe)
MY_SWIG		 := swig
MY_JAVA	 	 := "$(JAVA_BIN)/java"
MY_JAVAC	 := "$(JAVA_BIN)/javac"
ifneq ($(OS),android)
  MY_JNI_CFLAGS  := -I"$(JAVA_INC)" -I"$(JAVA_INC)/win32" \
		    -I"$(JAVA_INC)/linux" -I"$(JAVA_INC)/darwin" -I.
  MY_JNI_LDFLAGS := -L"$(JAVA_LIB)"
endif

# OS specific
ifeq ($(OS),Windows_NT)
  MY_JNI_LDFLAGS += -Wl,--kill-at
else
  MY_JNI_CFLAGS	 += -fPIC
  ifeq ($(OS),android)
    MY_JNI_CFLAGS+= -D__ANDROID__
    MY_JNI_LDFLAGS+= -Wl,-soname,libpjsua2.so
    MY_JNI_LDXXLIBS+= -landroid
    SWIG_FLAGS+= -D__ANDROID__
  endif
endif

# Build settings
MY_CFLAGS	 := $(PJ_CXXFLAGS) $(MY_JNI_CFLAGS) $(CFLAGS)
MY_LDFLAGS	 := $(PJ_LDXXFLAGS) $(PJ_LDXXLIBS) $(MY_JNI_LDXXLIBS) $(MY_JNI_LDFLAGS) $(LDFLAGS)
MY_PACKAGE_NAME	 := org.pjsip.pjsua2
ifeq ($(OS),android)
  MY_PACKAGE_PATH  := android/pjsua2/src/main/java/$(subst .,/,$(MY_PACKAGE_NAME))
else
  MY_PACKAGE_PATH  := $(OUT_DIR)/$(subst .,/,$(MY_PACKAGE_NAME))
endif

MY_APP_JAVA := android/app/src/main/java/$(subst .,/,$(MY_PACKAGE_NAME))/app/MyApp.java

.PHONY: all java install uninstall

all: $(LIBPJSUA2_SO) java

$(LIBPJSUA2_SO): $(OUT_DIR)/pjsua2_wrap.o
ifeq ($(OS),android)
	mkdir -p android/pjsua2/src/main/jniLibs/$(TARGET_ARCH)
	# copy libc++_shared.so manually
	cp -f ${ANDROID_NDK_ROOT}/sources/cxx-stl/llvm-libc++/libs/${TARGET_ARCH}/libc++_shared.so android/pjsua2/src/main/jniLibs/$(TARGET_ARCH)
endif
	$(PJ_CXX) -shared -o $(LIBPJSUA2_SO) $(OUT_DIR)/pjsua2_wrap.o \
		$(MY_LDFLAGS)

$(OUT_DIR)/pjsua2_wrap.o: $(OUT_DIR)/pjsua2_wrap.cpp Makefile
	$(PJ_CXX) -c $(OUT_DIR)/pjsua2_wrap.cpp -o $(OUT_DIR)/pjsua2_wrap.o \
		$(MY_CFLAGS)

$(OUT_DIR)/pjsua2_wrap.cpp: ../pjsua2.i ../symbols.i $(SRCS)
	mkdir -p $(MY_PACKAGE_PATH)
	mkdir -p $(OUT_DIR)
	swig $(SWIG_FLAGS) -java  -package $(MY_PACKAGE_NAME) \
		-outdir $(MY_PACKAGE_PATH) \
		-o $(OUT_DIR)/pjsua2_wrap.cpp ../pjsua2.i

clean distclean realclean:
	rm -rf $(LIBPJSUA2_SO) $(OUT_DIR)/* \
		$(MY_PACKAGE_PATH)/*.java $(MY_PACKAGE_PATH)/*.class \
		$(MY_PACKAGE_PATH)/../*.java $(MY_PACKAGE_PATH)/../*.class

java: $(MY_PACKAGE_PATH)/Error.class $(MY_PACKAGE_PATH)/test.class $(MY_PACKAGE_PATH)/sample.class
ifneq (,$(findstring PJMEDIA_VIDEO_DEV_HAS_ANDROID=1,$(ANDROID_CFLAGS)))
	@echo "Copying Android camera helper components..."
	cp $(PJDIR)/pjmedia/src/pjmedia-videodev/android/PjCamera*.java $(MY_PACKAGE_PATH)/..
endif
ifneq (,$(findstring PJMEDIA_AUDIO_DEV_HAS_OBOE=1,$(OBOE_CFLAGS)))
	@echo "Copying Android Oboe audio device helper components..."
	cp $(PJDIR)/pjmedia/src/pjmedia-audiodev/android/PjAudioDevInfo.java $(MY_PACKAGE_PATH)/..
endif

$(MY_PACKAGE_PATH)/Error.class: $(MY_PACKAGE_PATH)/Error.java
	$(MY_JAVAC) -d $(OUT_DIR) $(MY_PACKAGE_PATH)/*.java $(MY_APP_JAVA)

$(MY_PACKAGE_PATH)/test.class: test.java
	$(MY_JAVAC) -d $(OUT_DIR) -classpath "$(OUT_DIR)" test.java
	
$(MY_PACKAGE_PATH)/sample.class: sample.java
	$(MY_JAVAC) -d $(OUT_DIR) -classpath "$(OUT_DIR)" sample.java
	@# Build javafx sample app
	@# $(MY_JAVAC) -d $(OUT_DIR) -classpath "$(OUT_DIR)" sample2.java

test:
	@# Need to specify classpath and library path, alternatively,
	@# they can be set via CLASSPATH and java.library.path env settings
	$(MY_JAVA) -cp "$(OUT_DIR)" -Djava.library.path="$(OUT_DIR)" test
	
sample:
	@# Need to specify classpath and library path, alternatively,
	@# they can be set via CLASSPATH and java.library.path env settings
	$(MY_JAVA) -cp "$(OUT_DIR)" -Djava.library.path="$(OUT_DIR)" \
		org.pjsip.pjsua2.app.sample	
	@# This is for sample2 app
	@# $(MY_JAVA) -cp "$(OUT_DIR)" -Djava.library.path="$(OUT_DIR)" \
	@#	org.pjsip.pjsua2.app.sample2	        

install:
uninstall:

=== debian/changelog ===
ring (20230206.0~ds2-1.1+deb12u1) bookworm-security; urgency=high

  * Non-maintainer upload by the Security Team.
  * CVE-2023-27585: Embedded copy of PJSIP library has a buffer overflow in
    the DNS implementation. 

 -- Aron Xu <aron@debian.org>  Wed, 02 Jul 2025 15:29:21 +0800

ring (20230206.0~ds2-1.1) unstable; urgency=medium

  * Upload to unstable.

  * Upload sponsored by Petter Reinholdtsen.

 -- Amin Bandali <bandali@gnu.org>  Wed, 01 Mar 2023 00:05:32 -0500

ring (20230206.0~ds2-1) experimental; urgency=medium

  * Always build without Qt WebEngine to ship with a uniform set of
    features across supported architectures.  The features currently
    requiring Qt WebEngine (link previews, emoji picker, preview of
    shared media for some formats, and location sharing) are *not*
    core features without which Jami's use would be substantially
    hindered, and most (if not all) of them could be implemented
    natively and without using Qt WebEngine.
    - debian/control: Drop Qt WebEngine from dependencies.
    - debian/copyright: Excluded web-related files.
    - debian/rules: Always build without Qt WebEngine.
    - debian/source/lintian-overrides: Remove unneeded overrides.
  * Use the right Debian Source (ds) number in orig tarball name.
    - debian/rules: Get ds from the latest changelog entry and use it
      instead of hardcoding '~ds1'.
  * Add patch to change two CMake variables into proper options.
    - debian/patches/1010-cmake-options.patch: Change
      WITH_DAEMON_SUBMODULE and WITH_WEBENGINE into proper options.
      Also, pass src/libclient/webresource.qrc to qt_add_executable
      only if WITH_WEBENGINE.
  * Use dh_auto_* tools for the client.  The stopgap sed workaround
    for building without Qt WebEngine is no longer necessary.  The
    issue was calling out to dh_auto_configure but without the right
    flags, which would then overwrite/interfere with the flags
    specified in the earlier manual call to cmake.
  * debian/jami.lintian-overrides: Drop vestigial file.  This was
    previously added likely because the jami package used to ship a
    libringclient.a static library for use by the client, but after an
    upstream refactoring merging the Jami libclient sources into
    jami-client-qt.git, that is no longer needed.

  * Upload sponsored by Petter Reinholdtsen.

 -- Amin Bandali <bandali@gnu.org>  Sun, 26 Feb 2023 01:08:53 -0500

ring (20230206.0~ds1-6) experimental; urgency=medium

  * debian/control: Add libqt6sql6-sqlite to jami's Depends, needed
    for importing existing Jami accounts with non-swarm conversations,
    as well as SIP accounts (Closes: #1031692).
    Also, taking over the maintenance of the package; many thanks,
    Alexandre!
  * Address several lintian errors and warnings:
    - debian/copyright: Drop vestigial entries for nonexistent files.
    - debian/rules: Remove usr/lib/pkgconfig/jami.pc, since we
      currently don't ship the Jami daemon as a library.
    - debian/source/lintian-overrides: Update.

  * Upload sponsored by Petter Reinholdtsen.

 -- Amin Bandali <bandali@gnu.org>  Tue, 21 Feb 2023 01:08:33 -0500

=== debian/control ===
Source: ring
Section: comm
Priority: optional
Maintainer: Debian VoIP Team <pkg-voip-maintainers@lists.alioth.debian.org>
Uploaders: Amin Bandali <bandali@gnu.org>
Build-Depends: debhelper-compat (= 12),
               autoconf,
               automake,
               cmake,
               libtool,
# Qt client
               libnotify-dev,
               libnm-dev,
               libqrencode-dev,
               libqt6core5compat6-dev,
               libqt6networkauth6-dev,
               libqt6svg6-dev,
               qml6-module-qt-labs-platform,
               qml6-module-qt-labs-qmlmodels,
               qml6-module-qt5compat-graphicaleffects,
               qml6-module-qtmultimedia,
               qml6-module-qtqml-workerscript,
               qml6-module-qtquick3d-spatialaudio,
               qml6-module-qtquick,
               qml6-module-qtquick-controls,
               qml6-module-qtquick-dialogs,
               qml6-module-qtquick-layouts,
               qml6-module-qtquick-shapes,
               qml6-module-qtquick-templates,
               qml6-module-qtquick-window,
               qt6-5compat-dev,
               qt6-base-dev,
               qt6-declarative-dev,
               qt6-l10n-tools,
               qt6-multimedia-dev,
               qt6-positioning-dev,
               qt6-tools-dev,
               qt6-tools-dev-tools,
# daemon
               libdbus-1-dev,
               libdbus-c++-dev,
               libupnp-dev,
               libgnutls28-dev (>= 3.4.14),
               libssl-dev,
               libpulse-dev,
               libasound2-dev,
               libexpat1-dev,
               libpcre3-dev,
               libyaml-cpp-dev,
               libsndfile1-dev,
               libxext-dev,
               libxfixes-dev,
               libspeex-dev,
               libspeexdsp-dev,
               uuid-dev,
               libavcodec-dev,
               libavutil-dev (>= 7:3.4.2),
               libavformat-dev,
               libswscale-dev,
               libavdevice-dev,
               libopus-dev,
               libudev-dev,
               libgsm1-dev,
               libjsoncpp-dev,
               libnatpmp-dev,
               libva-dev,
               libopendht-dev (>= 2.4.12-5),
               libasio-dev,
               libcrypto++-dev,
               libargon2-dev,
               libvdpau-dev,
               libsecp256k1-dev,
               libfmt-dev,
               libhttp-parser-dev,
               libarchive-dev,
               libgit2-dev,
               libwebrtc-audio-processing-dev,
# other
               libmsgpack-cxx-dev | libmsgpack-dev (>= 1.4.2),
               libmsgpack-cxx-dev | libmsgpack-dev (<= 4.0.0),
               yasm,
               libsamplerate0-dev
Standards-Version: 4.6.2
Homepage: https://jami.net
Vcs-Git: https://salsa.debian.org/pkg-voip-team/ring.git
Vcs-Browser: https://salsa.debian.org/pkg-voip-team/ring
Rules-Requires-Root: no

Package: jami
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends},
         jami-daemon (=${binary:Version}),
         libqt6sql6-sqlite,
         qml6-module-qt-labs-platform,
         qml6-module-qt-labs-qmlmodels,
         qml6-module-qt5compat-graphicaleffects,
         qml6-module-qtmultimedia,
         qml6-module-qtqml-workerscript,
         qml6-module-qtquick3d-spatialaudio,
         qml6-module-qtquick,
         qml6-module-qtquick-controls,
         qml6-module-qtquick-dialogs,
         qml6-module-qtquick-layouts,
         qml6-module-qtquick-shapes,
         qml6-module-qtquick-templates,
         qml6-module-qtquick-window
Provides: jami-qt
Description: Secure and distributed voice, video, and chat platform - desktop client
 Jami is an end-to-end encrypted secure and distributed voice, video,
 and chat communication platform that requires no central server and
 leaves the power of privacy and freedom in the hands of users.
 .
 To some degree, Jami provides functionality similar to Telegram,
 BigBlueButton, Jitsi Meet, etc.
 .
 Jami supports the following key features:
   * One-to-one conversations
   * File sharing
   * Audio calls and conferences
   * Video calls and conferences
   * Screen sharing in video calls and conferences
   * Recording and sending audio messages
   * Recording and sending video messages
   * Functioning as a SIP phone software
 .
 Jami client applications for several desktop and mobile operating
 systems and platforms are available on https://jami.net/, making
 Jami an interoperable, cross-platform communication framework.
 .
 This package contains the Jami desktop client, jami (aka jami-qt).

Package: jami-daemon
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: Secure and distributed voice, video and chat platform - daemon
 Jami is an end-to-end encrypted secure and distributed voice, video,
 and chat communication platform that requires no central server and
 leaves the power of privacy and freedom in the hands of users.
 .
 To some degree Jami provides similar functionality like Telegram,
 BigBlueButton, Jitsi Meet, etc do.
 .
 Jami supports the following key features:
   * One-to-one conversations
   * File sharing
   * Audio calls and conferences
   * Video calls and conferences
   * Screen sharing in video calls and conferences
   * Recording and sending audio messages
   * Recording and sending video messages
   * Functioning as a SIP phone software
 .
 Jami client applications for several desktop and mobile operating
 systems and platforms are available on https://jami.net/, making
 Jami an interoperable, cross-platform communication framework.
 .
 This package contains the Jami daemon, jamid.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

include /usr/share/dpkg/architecture.mk
include /usr/share/dpkg/pkg-info.mk

# Hardening
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

# Build with LFS (See #913186)
CFLAGS += -D_LARGEFILE_SOURCE -D_FILE_OFFSET_BITS=64
CXXFLAGS += -D_LARGEFILE_SOURCE -D_FILE_OFFSET_BITS=64

# Number of CPUS
NO_CPUS=$(shell nproc)
ifeq ($(NO_CPUS),0)
NO_CPUS=1
endif

%:
	dh $@ --without autoreconf

override_dh_auto_configure:
# Re-create tarballs from tarballs-unpacked
	mkdir -p daemon/contrib/tarballs
	for i in $(CURDIR)/daemon/contrib/tarballs-unpacked/*; do \
	  projectname=`basename $$i` && \
	  cd $$i && tar -caf ../../tarballs/$$projectname * && \
	  echo "Repacked $$projectname"; \
	done

# Daemon configure
	mkdir -p daemon/contrib/native
	cd daemon/contrib/native && \
	  ../bootstrap \
	    --disable-downloads \
	    --no-checksums \
	    --disable-ogg \
	    --disable-flac \
	    --disable-gmp \
	    --disable-vorbis \
	    --disable-vorbisenc \
	    --disable-speex \
	    --disable-sndfile \
	    --disable-gsm \
	    --disable-speexdsp \
	    --disable-asio \
	    --disable-boost \
	    --disable-cryptopp \
	    --disable-ffmpeg \
	    --disable-restbed \
	    --disable-vpx \
	    --disable-x264 \
	    --disable-yaml-cpp \
	    --disable-opendht \
	    --disable-gnutls \
	    --disable-dbus-cpp \
	    --disable-secp256k1 \
	    --disable-upnp \
	    --disable-asio \
	    --disable-restinio \
	    --disable-fmt \
	    --disable-http_parser \
	    --disable-libarchive \
	    --disable-natpmp \
	    --disable-libgit2 \
	    --disable-webrtc-audio-processing && \
	  make list && \
	  make -j$(NO_CPUS) V=1
ifneq (,$(filter $(DEB_HOST_ARCH), armel mipsel))
# Link atomic library
	sed -i '/libclient_dbus.la/s/libjami.la/& -latomic/' \
	  daemon/bin/Makefile.am
endif
	cd daemon && \
	  ./autogen.sh && \
	  ./configure \
	    --prefix=/usr \
	    --disable-shared

# Qt client configure
	dh_auto_configure -- \
	  -DWITH_DAEMON_SUBMODULE=true \
	  -DWITH_WEBENGINE=false

override_dh_auto_build:
# Daemon build
	make -C daemon -j$(NO_CPUS) V=1
	pod2man daemon/man/jamid.pod > daemon/jamid.1

# Qt client build
	dh_auto_build

override_dh_auto_clean:
# Generated contrib tarballs
	rm -rfv daemon/contrib/tarballs

# Daemon clean
	[ -f daemon/contrib/native/Makefile ] && \
	  make -C daemon/contrib/native distclean || true
	rm -rfv daemon/contrib/native
	rm -rfv daemon/jamid.1

# Qt client clean
	dh_auto_clean

override_dh_auto_install:
# Daemon install
	cd daemon && make DESTDIR=$(CURDIR)/debian/jami-daemon install
	rm -rfv $(CURDIR)/debian/jami-daemon/usr/include
	rm -rfv $(CURDIR)/debian/jami-daemon/usr/lib/*.a
	rm -rfv $(CURDIR)/debian/jami-daemon/usr/lib/*.la
	rm -rfv $(CURDIR)/debian/jami-daemon/usr/lib/pkgconfig
	rm -rv  $(CURDIR)/debian/jami-daemon/usr/lib
# CMake files
	rm -rfv $(CURDIR)/debian/jami/usr/lib/cmake

# Qt client install
	dh_auto_install --destdir=$(CURDIR)/debian/jami

# Work around dak not liking files with timestamps too far in the past
execute_before_dh_strip_nondeterminism:
	find $(CURDIR)/debian/jami/ ! -newermt "jan 01, 2000" \
	  -exec touch --date="@$(SOURCE_DATE_EPOCH)" {} +


tmp_dir := $(shell mktemp -d)
version := $(shell dpkg-parsechangelog -ldebian/changelog | perl -ne \
                   'print $$1 if m{^Version:\s+(?:\d+:)?(\d.*)(?:\~ds.+)(?:\-\d+.*)};')
ds := $(shell dpkg-parsechangelog -ldebian/changelog | perl -ne \
              'print $$1 if m{^Version:\s+(?:\d+:)?(?:\d.*)(\~ds.+)(?:\-\d+.*)};')
pj := $(tmp_dir)/jami-*/daemon/contrib/tarballs-unpacked/pjproject-*/pjproject-*

# Repack the tarball with contrib tarballs unpacked
get-orig-source:
# Download jami tarball
	if [ -n "$$GET_ORIG_SOURCE_OVERRIDE_USCAN_TARBALL" ]; then \
	  mv $$GET_ORIG_SOURCE_OVERRIDE_USCAN_TARBALL $(tmp_dir); \
	else \
	  uscan \
	    --rename \
	    --destdir=$(tmp_dir) \
	    --download-version $(version); \
	fi

# Unpack jami tarball
	tar -C $(tmp_dir) -xf $(tmp_dir)/*.tar.*

# Remove original tarball
	rm $(tmp_dir)/*.tar.*

# Unpack all of the orig tarballs into tarballs-unpacked
	cd $(tmp_dir)/jami-*/daemon/contrib && \
	  mkdir tarballs-unpacked && \
	  for i in `find tarballs/ -name "*.tar.*"`; do \
	    project_name=`basename $$i` && \
	    mkdir tarballs-unpacked/$$project_name && \
	    tar -C tarballs-unpacked/$$project_name -xf $$i && \
	    echo "Unpacked $$project_name"; \
	  done

# Exclude files
#   This does not exclude everything that we need to exclude; so
#   debian/copyright's Files-Excluded section also excludes files.
	rm -rf $(pj)/build/vs # not needed, Visual Studio files
	rm -f  $(pj)/pjmedia/src/pjmedia-audiodev/s60_g729_bitstream.h # non distributable
	rm -f  $(pj)pjsip-apps/src/pjsua/android/gradle/wrapper/* # not needed
	rm -r  $(pj)/pjsip-apps/src/swig/java/android/gradle/wrapper/* # not needed
	rm -rf $(pj)/third_party/g7221 # non-distributable (requires a license from Polycom)
	rm -rf $(pj)/third_party/ilbc # non distributable (the version included with pjproject)
	rm -rf $(pj)/third_party/milenage # non distributable
	rm -rf $(pj)/third_party/BaseClasses # non distributable (?)
	rm -rf $(pj)/third_party/portaudio # not needed
	rm -rf $(pj)/third_party/speex # not needed
	rm -rf $(pj)/third_party/mp3 # not needed
	rm -rf $(pj)/third_party/gsm # not needed
	rm -rf $(pj)/third_party/bdsound # not needed

# Remove all contrib tarballs
	rm -rf $(tmp_dir)/jami-*/daemon/contrib/tarballs

# Create the new tarball
	cd $(tmp_dir) && \
	  tar -czf \
	    $(CURDIR)/../ring_$(version)$(ds).orig.tar.gz \
	    jami-*

# Remove the temporary directory
	rm -rf $(tmp_dir)

=== debian/watch ===
version=4
opts=dversionmangle=auto \
https://dl.jami.net/release/tarballs/ jami-(\d\S+)\.tar\.gz
